unit FileFunction;


interface
uses
   Classes,SysUtils,windows;
//CXƧUҦɮ
function ListDirFile(Path:String):TStrings;

//`ɮפwr
function FindFileWord(Files:TFileStream;Str:String):Boolean;

//X@ӤsbɦW
function FindUniqueFileName(FileName:String):String;

//Ū@xOAudio CD
function IfAudioCD(S:String):Boolean;
//ŪоϺнs
function FindCDROMCount:String;

implementation

//CXƧUҦɮ
function ListDirFile(Path:String):TStrings;
var
  Sr:TSearchRec;
begin
  //pؿsb
  if not DirectoryExists(Path) then Exit;
  Result:=TStringList.Create;
  //if Path have not '\' add '\' to path
  if Path[Length(Path)]<>'\' then Path:=Path+'\';

  if FindFirst(Path+'*.*',faAnyFile,Sr)=0 then
  begin
    repeat
      //Finding File  Attribute is not Directory
      if (Sr.Attr and faDirectory) <> faDirectory then
           Result.Add(Path+ Sr.Name);
      
    Until FindNext(Sr)<>0;
    SysUtils.FindClose(SR);
  end;
end;

//`ɮפwr
function FindFileWord(Files:TFileStream;Str:String):Boolean;
var
 S1,S2,St1,St2:String;
 T1:Integer;
begin
  Result:=False;
  if (Str='') and (Length(Str)=1) then Exit;
  SetLength(S1,1);
  T1:=Length(Str)-1;
  SetLength(S2,T1);
  St1:=UpperCase(Copy(Str,1,1));
  St2:=UpperCase(Copy(Str,2,T1));
  While (True) do
  begin
     //S
     if Files.size=Files.Position then Exit;

     Files.Read(S1[1],1);
     S1:=UpperCase(S1);
     if S1=St1 then
     begin
        Files.Read(S2[1],T1);
        S2:=UpperCase(S2);
        if (S2=St2) then
        begin
           Result:=True;
           Exit;
        end;
        Files.Seek(T1,1);
     end;
  end;
  Files.Seek(0,soFromBeginning); 
end;

//X@ӤsbɦW
function FindUniqueFileName(FileName:String):String;
var
  I:Integer;
  TmpFile,tmpExt,tmp:String;
begin
   I:=0;
   if FileExists(FileName) then
   begin
      tmpExt:=ExtractFileExt(FileName);
      tmp:=ExtractFileName(FileName);
      tmpFile:=copy(tmp,1,Length(tmp)-Length(tmpExt));

      while(I<1000) do
      begin
         if not FileExists(TmpFile+Format('%d',[I])+tmpExt) then
         begin
            Result:=TmpFile+Format('%d',[I])+tmpExt;
            Exit;
         end;
         Inc(I);
      end;
   end
   else
      Result:=FileName;
end;
//Ū@xOAudio CD
function IfAudioCD(S:String):Boolean;
var
 I,Flag:Cardinal;
 vo:PChar;
begin
   Result:=False;
   vo:=Stralloc(Max_Path);
   GetVolumeInformation(PChar(S),Vo,Max_Path,nil,I,Flag,nil,0);
   if Vo='Audio CD' then
      Result:=True;
end;
//ŪоϺнs
function FindCDROMCount:String;
var
  T,T1:PChar;
  P:string;
  I:Integer;
begin
  T:=Stralloc(MAX_PATH);
  T1:=T;
  if GetLogicalDriveStrings(MAX_PATH,T)=0 then
     raise Exception.Create('Can not get Drives info')
  else
  begin
  Result:='';
     while (T^<>#0) do
     begin
         P:=StrPas(T);
         if GetDriveType(PChar(P))=DRIVE_CDROM then
            Result:=Result+P+' ';
         I:=StrLen(T);
         Inc(Integer(T),I+1);
     end;
  end;
  StrDispose(T1);
end;
end.
