unit CDFunction;

interface
   uses Classes,SysUtils,FileFunction;
   type
     PCDFormat=^TCDFormat;
     TCDFormat=record
       CDAFileVer:Smallint;
       NumberofTrack:Smallint;
       CDSerial:Cardinal;
       HSGBegin:Cardinal;
       HSGLen:Cardinal;
       BRBFrame:Byte;
       BRBSecond:Byte;
       BRBMinute:Byte;
       BRBNo:Byte;
       BRLFrame:Byte;
       BRLSecond:Byte;
       BRLMinute:Byte;
       BRLNo:Byte;
      end;

//MCD Format
function FindCDFormat(FileName:TFileStream;var CD:TCDFormat):Boolean;




implementation
//MCD Format
function FindCDFormat(FileName:TFileStream;var CD:TCDFormat):Boolean;
begin
   Result:=True;
   //RIFF
   if not FindFileWord(FileName,'RIFF') then
      Result:=False;
   //CDDA
   if Not FindFileWord(FileName,'CDDA') then
      Result:=False;
   //fmt
   if not FindFileWord(FileName,'fmt ') then
      Result:=False;
   if not Result then Exit;
   FileName.Seek(4,1);
   FileName.Read(CD,Sizeof(CD));



end;
end.
